



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深入理解JavaScript 事件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深入理解JavaScript 事件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 13:45:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ul><li>本文总结自《JavaScript高级程序设计》以及自己平时的经验，针对较新浏览器以及 DOM3 级事件标准（2016年8月），对少部分内容作了更正，增加了各种例子及解析。</li>
<li>如无特殊说明，本文后的文字引用和图片引用均来自《JavaScript高级程序设计》，引用稍有改变原文，不改变意思。</li>
<li>本文仅作巩固基础之用，如果有不正确的地方，还望指出。</li>
<li><a href="https://luckylzh.github.io/2016/07/30/JavaScript-%E4%BA%8B%E4%BB%B6%E6%80%BB%E7%BB%93/" rel="external nofollow noreferrer">更好的排版可以点这里</a></li></ul>
<h2>事件</h2>
<p>个人认为：不论是浏览器自带的事件，还是自定义事件，都是观察者模式的实现。更确切地说：事件流是会流动的，流到哪个节点，事件在哪里发生，事件发生时，节点便会调用在这个节点绑定的事件处理程序。节点是被观察者，事件处理程序是观察者，当事件流流到被观察者时，被观察者会对外宣称&ldquo;我这里发生了某个事件&rdquo;，即通知观察者，也就是节点调用事件处理程序。事件流是不知道被观察者有多少个的，所以即使是0个，事件流也会继续流，流到节点时，节点会遍历自己注册的事件处理程序，存在就调用。具体浏览器的实现和优化肯定更加复杂和精妙，但原理应该是这样（以上为个人理解）。</p>
<h2>事件流</h2>
<p>事件流分为事件冒泡和事件捕获：</p>
<blockquote><ul><li>如果你把手指放在圆心上，那么你的手指指向的不是一个圆，而是纸上的所有圆。在浏览器上单击按钮的同时，你也单击了按钮的容器元素，甚至也单击了整个页面。事件流描述的是<strong>从页面中接收事件的顺序</strong>。</li>
<li>IE开发团队提出了事件冒泡流、Netscape开发团队提出了事件捕获流。</li></ul></blockquote>
<h3>事件冒泡</h3>
<blockquote><ul><li>事件开始时由最具体的元素（文档中嵌套层次最深的那个节点）接收，然后逐级向上传播到较为不具体的节点，所有现代浏览器都支持事件冒泡，除IE5.5外，均一直冒泡到window。</li>
<li>事件冒泡示意图：
<p><img referrerpolicy="no-referrer"src="https://luckylzh.github.io/2016/07/30/JavaScript-%E4%BA%8B%E4%BB%B6%E6%80%BB%E7%BB%93/eventBubbling.jpg" /></li></ul></blockquote>
<h3>事件捕获</h3>
<blockquote><ul><li>不太具体的节点应该更早接收到事件，而最具体的节点应该最后接收到事件。事件捕获的用意在于<strong>在事件到达预定目标之前捕获它</strong>。IE9+、Safari、Chrome、Opera和Firefox支持，且从window开始捕获（尽管DOM2 级事件规范要求从document）。</li>
<li>事件捕获示意图：
<p><img referrerpolicy="no-referrer"src="https://luckylzh.github.io/2016/07/30/JavaScript-%E4%BA%8B%E4%BB%B6%E6%80%BB%E7%BB%93/eventCapturing.png" /></li>
<li>由于<strong>老版本的浏览器不支持</strong>，因此很少有人使用事件捕获。我们也建议读者<strong>放心地使用事件冒泡，在有特殊需要时再使用事件捕获</strong>。</li></ul></blockquote>
<ul><li><p>为了彻底理解事件冒泡和捕获，这里写了个例子：</p>
<div>
<pre class="prettyprint linenums"><code>&lt;!DOCTYPE html&gt;<br />
&lt;html lang="zh-cn"&gt;<br />
&lt;head&gt;<br />
&lt;meta charset="UTF-8"&gt;<br />
&lt;title&gt;test1&lt;/title&gt;<br />
&lt;link rel="stylesheet" href="test1.css"&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
&lt;div id="a"&gt;<br />
    &lt;div id="b"&gt;<br />
        &lt;div id="c"&gt;&lt;/div&gt;<br />
    &lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script src="test1.js"&gt;&lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</code></pre>
</div></li></ul>
<div>
<pre class="prettyprint linenums"><code>#a{<br />
    width: 300px;<br />
    height: 300px;<br />
    background: pink;<br />
}

#b{<br />
    width: 200px;<br />
    height: 200px;<br />
    background: blue;<br />
}

#c{<br />
    width: 100px;<br />
    height: 100px;<br />
    background: yellow;<br />
}</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>var a = document.getElementById("a"),<br />
    b = document.getElementById("b"),<br />
    c = document.getElementById("c");

    c.addEventListener("click", function(event){<br />
        console.log("c1")<br />
        // 注意第三个参数没有传进 false , 因为默认传进来的是 false，代表冒泡阶段调用，个人认为处于目标阶段也会调用的<br />
    });<br />
    c.addEventListener("click", function(event){<br />
        console.log("c2");<br />
    }, true);<br />
    b.addEventListener("click", function(event){<br />
        console.log("b");<br />
    }, true);<br />
    a.addEventListener("click", function(event){<br />
        console.log("a1");<br />
    }, true);<br />
    a.addEventListener("click", function(event){<br />
        console.log("a2")<br />
    });<br />
    a.addEventListener("click", function(event){<br />
        console.log("a3");<br />
        event.stopImmediatePropagation();<br />
    }, true);<br />
    a.addEventListener("click", function(event){<br />
        console.log("a4");<br />
    }, true);</code></pre>
</div>
<ul><li><p>效果如图<br /><img referrerpolicy="no-referrer"src="https://luckylzh.github.io/2016/07/30/JavaScript-%E4%BA%8B%E4%BB%B6%E6%80%BB%E7%BB%93/eventFlow.png" /></p></li>
<li><strong>点击 c 或 b，输出：a1、a3</strong></li>
<li>stopImmediatePropagation 包含了 stopPropagation 的功能，即阻止事件传播（捕获或冒泡），但同时也阻止该元素上后来绑定的事件处理程序被调用，所以不输出 a4，因为事件捕获被拦截了，自然不会触发 b、c 上的事件，所以不输出 b、c1、c2，冒泡更谈不上了，所以不输出 a2。有人会觉得上面的表述有一点点问题，为什么捕获被拦截了，c1 就不输出了呢？ c1 应该是冒泡阶段被调用的呀，所以应该改为另一个表述：&ldquo;...冒泡更谈不上，所以不输出 c1、a2&rdquo;。但另一个表述是错的，下面会分析到。</li>
<li><strong>点击 a，输出 a1、a2、a3</strong></li>
<li>不应该是 a1、a3、a2 吗？a1、a3 可是在捕获阶段被调用的处理程序啊，a2 是在冒泡阶段被调用的啊。这里正是要说明的：虽然这三个事件处理程序注册时指定了true、false，但现在事件流是处于目标阶段，不是冒泡阶段、也不是捕获阶段，事件处理程序被调用的顺序是注册的顺序。不论你指定的是 true or false. 这也解释了上面提到的&ldquo;另一种表述&rdquo;为什么是错误的。</li>
<li>更深一步解释是：要区分事件流和事件处理程序，不论事件处理程序存不存在，事件流都会传播。这是一个观察者模式，绑定事件的节点是被观察者、事件处理程序是观察者，事件流是不知道观察者的存在的，所以你点击页面的时候，事件流一定要传播，传播到某一个节点时，节点去通知所有观察者，也就是调用事件处理程序（有可能观察者不存在）。</li>
<li>当一个事件流来到一个节点时，事件流可能在捕获阶段（正在流向最深层次的节点）、可能在处于目标阶段（已经流到了目标，也就是event.target）、也可能在冒泡阶段（正在流向最外层节点）。而事件处理程序是这么处理的：① 注册时第三个参数指定为 true 时，事件流到来，如果事件流是捕获阶段或处于目标阶段，则调用该事件处理程序。②注册时第三个参数指定为 false 时，当事件流到来，如果事件流是处于目标阶段或冒泡阶段，则调用该事件处理程序。</li>
<li>所以当事件流是处于目标阶段，那么不管事件处理程序第三个参数指定的true or false，事件处理程序都会被调用，调用顺序按照注册顺序。所以点击a，输出 a1、a2、a3，而不是a1、a3、a2。</li>
<li><p><strong>注释掉 event.stopImmediatePropagation，点击 c，输出 a1、a3、a4、b、c1、c2、a2</strong></p></li>
<li><p>另外，如果同一个事件处理程序（指针相同，比如用 handler 保存的事件处理程序），用 addEventListener 或 attachEvent 绑定多次，如果第三个参数是相同的话，也只会被调用一次。但如果第三个参数一个设置为true，另一个设置为false，那么会被调用两次。</p></li></ul>
<h3>DOM事件流</h3>
<blockquote><ul><li>&ldquo;DOM2级事件&rdquo;规定的事件流包括三个阶段：<strong>事件捕获阶段、处于目标阶段和事件冒泡阶段</strong>。首先发生的是事件捕获，为截获事件提供了机会。然后是实际的目标接收到事件。最后一个阶段是冒泡阶段。（<strong>事件处理中&ldquo;处于目标阶段&rdquo;被看成冒泡阶段的一部分</strong>）。</li>
<li>IE9、Safari、Chrome、Firefox和Opera9.5及更高版本都会在捕获阶段触发事件对象上的事件，就是<strong>有两个机会在目标对象上面操作事件</strong>。（尽管DOM2级事件规范明确要求捕获阶段不涉及事件目标）。</li></ul></blockquote>
<h2>事件处理程序</h2>
<h3>HTML 事件处理程序</h3>
<p>简单来讲，HTML 事件处理程序是直接在HTML中绑定事件，如下</p>
<div>
<pre class="prettyprint linenums"><code>&lt;input type="button" value="Click Me" onclick="alert(&amp;quot;Clicked&amp;quot;)" /&gt;</code></pre>
</div>
<h4>注意事项：</h4>
<ul><li>不能在其中使用未经转义的HTML语法字符，如<code>&amp;</code>、<code>&ldquo;&rdquo;</code>、<code>&lt;</code>、<code>&gt;</code>，因为这是在HTML中绑定的，会造成浏览器解析DOM结构错误。</li>
<li><p>扩展函数作用域，来看下面的代码：</p>
<div>
<pre class="prettyprint linenums"><code>&lt;!-- 输出 "Click Me、lzh" --&gt;<br />
&lt;form method="post"&gt;<br />
  &lt;input type="text" name="username" value="lzh"&gt;<br />
  &lt;input type="button" value="Click Me" onclick="alert(value);alert(username.value);"&gt;<br />
&lt;/form&gt;</code></pre>
</div>
<p>如果当前元素是一个表单输入元素，浏览器内部大概是这样实现的：</p>
<div>
<pre class="prettyprint linenums"><code>function () {<br />
with (document) {<br />
    with (this.form) {<br />
        with (this) {<br />
            //元素属性值<br />
        }<br />
    }<br />
}<br />
}</code></pre>
</div>
<p>如果没有<code>form</code>元素，调用<code>username</code>会报错，所以不论是服务端渲染还是Ajax请求回来数据再渲染，最好还是把form结构写完整。<br />扩展作用域有三个缺点：</li></ul>
<ol><li>函数被调用时还没定义会报错，只好<code>try{}catch(ex){}</code>，分离的写法可以在DOMContentLoaded之后再绑定。</li>
<li>扩展的作用域链在不同浏览器中会导致不同的结果。</li>
<li>HTML 与 JavaScript 代码紧密耦合，如果要更换事件处理程序，需要改动 HTML 代码和 JavaScript代码。</li></ol>
<h3>DOM0级事件处理程序</h3>
<blockquote><ul><li>每个元素（包括<code>window</code>&nbsp;和<code>document</code>）都有自己的事件处理程序属性，<strong>这些属性通常全部小写</strong>。使用 DOM0 级指定的事件处理程序被认为是元素的方法。<code>this</code>&nbsp;引用当前元素。通过&nbsp;<code>this</code>&nbsp;可以访问元素的任何属性和方法。DOM0 级事件处理程序在冒泡阶段被处理。</li></ul></blockquote>
<div>
<pre class="prettyprint linenums"><code>var btn = document.getElementById("myBtn");<br />
btn.onclick = function () {<br />
    alert(this.id); //"myBtn"<br />
};</code></pre>
</div>
<h3>DOM2级事件处理程序</h3>
<blockquote><ul><li><code>addEventListener()</code>&nbsp;包含三个参数，要处理的事件名、事件处理函数、布尔值，布尔值为true，表示在捕获阶段调用事件处理程序，反之在冒泡阶段调用。</li>
<li>DOM2 级事件处理程序中的&nbsp;<code>this</code>&nbsp;也指向&nbsp;<code>addEventListener</code>&nbsp;的那个元素。</li>
<li>可以添加多个事件处理程序，按添加顺序依次调用。</li>
<li><code>removeEventListener</code>&nbsp;无法移除匿名函数的事件处理程序。</li></ul></blockquote>
<div>
<pre class="prettyprint linenums"><code>var btn = document.getElementById("myBtn");<br />
var handler = function () {<br />
    alert(this.id);<br />
};<br />
btn.addEventListener("click", handler, false);<br />
//这里省略了其他代码<br />
btn.removeEventListener("click", handler, false); // 有效！</code></pre>
</div>
<blockquote><ul><li><strong>IE9、Firefox、Safari、Chrome 和Opera 支持DOM2 级事件处理程序。</strong></li></ul></blockquote>
<h3>IE事件处理程序</h3>
<blockquote><ul><li><code>attachEvent</code>&nbsp;<code>detachEvent</code>&nbsp;接收两个参数，事件处理程序名称、事件处理程序函数。由于IE8及更早版本只支持事件冒泡，所以该事件处理程序只支持事件冒泡。</li>
<li>老版本的Opera支持这种方法，但现在Opera已经改用blink内核，IE11已经不支持这种方法，注意 IE9 就已经支持 DOM2 级事件处理程序了。</li>
<li>特别要注意：第一个参数包含on，比如onclick。</li>
<li>区别于DOM0 级事件处理程序，<code>this</code>&nbsp;指向 'window'。</li>
<li>也可以添加多个事件处理程序。</li></ul></blockquote>
<h3>跨浏览器的事件处理程序</h3>
<div>
<pre class="prettyprint linenums"><code>var EventUtil = {<br />
    addHandler: function(element, type, handler){<br />
        if (element.addEventListener){<br />
            element.addEventListener(type, handler, false);<br />
        } else if (element.attachEvent){<br />
            element.attachEvent("on" + type, handler);<br />
        } else {<br />
            element["on" + type] = handler;<br />
        }<br />
    },<br />
    removeHandler: function(element, type, handler){<br />
        if (element.removeEventListener){<br />
            element.removeEventListener(type, handler, false);<br />
        } else if (element.detachEvent){<br />
            element.detachEvent("on" + type, handler);<br />
        } else {<br />
            element["on" + type] = null;<br />
        }<br />
    }<br />
};</code></pre>
</div>
<blockquote><ul><li>存在问题：</li></ul>
<ol><li>IE事件处理程序 中的&nbsp;<code>this</code>&nbsp;指向&nbsp;<code>window</code>。</li>
<li>只支持 DOM0 级的浏览器不能多次添加事件处理程序，不过这种浏览器应该不多了，即使是IE8 也支持attachEvent。</li>
<li>会不会有一些事件，在浏览器支持 DOM2 级事件处理程序的情况下，那些事件只能用&nbsp;<code>on + name</code>&nbsp;的形式呢？ 之前一直怀疑 (1).<code>xhr.onreadystatechange()</code>&nbsp;和 (2).<code>DOMNodeInserted</code>&nbsp;事件，这里我多虑了，经过验证，(1).是支持 DOM2 级事件的，(2).天生就是 DOM2 级的。这里只是为了打消我的疑虑，记录下来。</li></ol></blockquote>
<h2>事件对象</h2>
<h3>DOM 中的事件对象</h3>
<blockquote><ul><li>兼容 DOM 的浏览器会将一个&nbsp;<code>event</code>&nbsp;对象传入事件处理程序， IE9 及更高版本可以。无论指定事件处理程序时使用什么方法（DOM0 级 DOM2 级），HTML 事件处理程序可以通过访问&nbsp;<code>event</code>&nbsp;变量得到&nbsp;<code>event</code>&nbsp;对象。</li>
<li>event 中的属性和方法都是只读的</li>
<li>常用属性：</li></ul>
<ol><li><code>target</code>&nbsp;事件的目标</li>
<li><code>currentTarget</code>&nbsp;绑定事件的元素，与 'this' 的指向相同</li>
<li><code>stopPropagation()</code>&nbsp;取消事件的进一步捕获或冒泡。如果bubbles为true，则可以使用这个方法</li>
<li><code>stopImmediatePropagation()</code>&nbsp;取消事件的进一步捕获或冒泡，同时阻止任何事件处理程序被调用（DOM3级事件中新增）</li>
<li><code>preventDefault()</code>&nbsp;取消事件的默认行为，比如点击链接跳转。如果&nbsp;<code>cancelable</code>&nbsp;是&nbsp;<code>true</code>，则可以使用这个方法</li>
<li><code>type</code>&nbsp;被触发的事件类型</li>
<li><code>eventPhase</code>&nbsp;调用事件处理程序的阶段：1表示捕获阶段，2表示&ldquo;处于目标&rdquo;，3表示冒泡阶段</li></ol>
<ul><li><code>this</code>&nbsp;<code>target</code>&nbsp;<code>currentTarget</code>&nbsp;举例：</li></ul></blockquote>
<div>
<pre class="prettyprint linenums"><code>document.body.onclick = function(event){<br />
    alert(event.currentTarget === document.body); //true<br />
    alert(this === document.body); //true<br />
    alert(event.target === document.getElementById("myBtn")); //true<br />
};</code></pre>
</div>
<blockquote><ul><li>通过&nbsp;<code>event.type</code>&nbsp;与&nbsp;<code>switch case</code>&nbsp;组合，可以通过一个函数处理多个事件。</li>
<li>只有在事件处理程序执行期间，<code>event</code>&nbsp;对象才会存在；一旦事件处理程序执行完成，<code>event</code>&nbsp;对象就会被销毁。</li></ul></blockquote>
<h3>IE 中的事件对象</h3>
<blockquote><ul><li>DOM0 级的事件处理程序，<code>event</code>&nbsp;作为&nbsp;<code>window</code>&nbsp;的一个属性存在。（从 IE9 开始，event 可以从参数中获得）</li>
<li><code>attachEvent</code>&nbsp;添加的事件处理程序，<code>event</code>&nbsp;作为参数传入，也可以通过&nbsp;<code>window</code>&nbsp;来访问&nbsp;<code>event</code>&nbsp;对象。</li>
<li>HTML 事件处理程序依然可以通过访问&nbsp;<code>event</code>&nbsp;变量得到&nbsp;<code>event</code>&nbsp;对象。</li>
<li>属性和方法：</li></ul>
<ol><li><code>cancelBubble</code>&nbsp;设置&nbsp;<code>true</code>&nbsp;or&nbsp;<code>false</code>&nbsp;可以取消事件冒泡</li>
<li><code>returnValue</code>&nbsp;设置&nbsp;<code>true</code>&nbsp;or&nbsp;<code>false</code>&nbsp;可以取消事件的默认行为。</li>
<li><code>srcElement</code>&nbsp;事件的目标（与DOM中的&nbsp;<code>target</code>&nbsp;相同）</li></ol>
<ul><li>注意事项：</li></ul>
<ol><li><code>attachEvent</code>&nbsp;中的&nbsp;<code>event.srcElement === this</code>&nbsp;吗？ 答案是否定的，因为前面说到过&nbsp;<code>attachEvent</code>&nbsp;中&nbsp;<code>this</code>&nbsp;指向&nbsp;<code>window</code>, DOM0 级、DOM2 级 事件处理程序&nbsp;<code>this</code>&nbsp;才指向&nbsp;<code>event.target / window.event.srcElement</code></li></ol></blockquote>
<h3>跨浏览器的事件对象</h3>
<div>
<pre class="prettyprint linenums"><code>var EventUtil = {<br />
    getEvent: function(event){<br />
        return event ? event : window.event; // window.event DOM0级时IE<br />
    },<br />
    getTarget: function(event){<br />
        return event.target || event.srcElement; // event.srcElement for IE<br />
    },<br />
    preventDefault: function(event){<br />
        if (event.preventDefault){<br />
            event.preventDefault();<br />
        } else {<br />
            event.returnValue = false; // IE<br />
        }<br />
    },<br />
    stopPropagation: function(event){<br />
        if (event.stopPropagation){<br />
            event.stopPropagation();<br />
        } else {<br />
            event.cancelBubble = true; // IE<br />
        }<br />
    }<br />
};</code></pre>
</div>
<h2>事件类型</h2>
<blockquote><ul><li>DOM3 级事件规定了几类事件；HTML5 也定义了一组事件；还有一些事件没有规范，浏览器的实现不一致。</li>
<li>DOM3 级事件模块在 DOM2 级事件模块基础上重新定义了这些事件，也添加了一些新事件。包括 IE9 在内的所有主流浏览器都支持 DOM2 级事件。IE9 也支持 DOM3 级事件。</li></ul></blockquote>
<p>这里只总结一些常见的事件类型</p>
<h3>UI事件类型</h3>
<blockquote><ul><li>load 事件，当页面完全加载后（包括所有图像、JavaScript 文件、CSS 文件等外部资源），就会触发&nbsp;<code>window</code>&nbsp;上面的 load 事件。</li></ul></blockquote>
<div>
<pre class="prettyprint linenums"><code>EventUtil.addHandler(window, "load", function(){<br />
    var image = document.createElement("img");<br />
    EventUtil.addHandler(image, "load", function(event){<br />
        event = EventUtil.getEvent(event);<br />
        alert(EventUtil.getTarget(event).src);<br />
    });<br />
    document.body.appendChild(image);<br />
    image.src = "smile.gif"; //在此之前要先指定事件处理程序<br />
});</code></pre>
</div>
<blockquote><ol><li>script 元素也会触发 load 事件，据此可以判断动态加载的 JavaScript 文件是否加载完毕。<strong>与图像不同，只有在设置了 script 元素的 src 属性并将该元素添加到文档后，才会开始下载 JavaScript 文件</strong></li>
<li>IE8 及更早版本不支持 script 元素上的 load 事件。</li>
<li>在不属于 DOM 文档的图像（包括未添加到文档的 img 元素和 Image 对象）上触发 load 事件时，IE8 及之前版本不会生成 event 对象。IE9 修复了这个问题。</li></ol></blockquote>
<blockquote><ul><li>resize 事件</li></ul></blockquote>
<blockquote><ol><li>浏览器窗口大小发生变化时会触发该事件，这个事件在&nbsp;<code>window</code>&nbsp;上触发，IE、Safari、Chrome 和 Opera 会在浏览器窗口变化了 1 像素时就触发 resize 事件，然后随着变化不断重复触发。Firefox 则只会在用户停止调整窗口大小时才会触发。</li>
<li>注意不要在这个事件的处理程序中加入大计算量的代码，或者采用函数节流的方式优化性能。</li>
<li>浏览器窗口最小化或最大化时也会触发 resize 事件。</li></ol></blockquote>
<blockquote><ul><li>scroll 事件</li></ul></blockquote>
<blockquote><ol><li>该事件在 window 上发生，此处和书上讲的有点不一样，webkit 内核或 blink 内核的浏览器（Chrome、Opera、Safari）可以通过 document.body.scrollTop 获取页面被卷去的高度，而 Trident、Gecko （IE、火狐）可以通过 document.documentElement.scrollTop来获取该值。</li>
<li>另外标准模式、混杂模式这两种方法还有出入，此处不讨论。</li>
<li>所以最好通过&nbsp;<code>document.body.scrollTop + document.documentElement.scrollTop</code>&nbsp;的方式获取 scrollTop 的值，因为两者之一会等于0，或者使用&nbsp;<code>document.body.scrollTop || document.documentElement.scrollTop</code>，两者效果一致。</li></ol></blockquote>
<h3>焦点事件</h3>
<blockquote><ol><li>这里忽略 DOMFocusIn、DOMFocusOut，因为只有 Opera 支持这个事件，且 DOM3 级事件废弃了它们。</li>
<li>blur：在元素失去焦点时触发。这个事件不会冒泡；所有浏览器都支持它。</li>
<li>focus：在元素获得焦点时触发。这个事件不会冒泡；所有浏览器都支持它。</li>
<li>focusin：与 focus 等价，但它冒泡。</li>
<li>focusout：与 blur 等价，也冒泡。</li>
<li>支持 focusin、focusout 的浏览器有：IE5.5+、Safari 5.1+、Opera 11.5+和Chrome。但只支持 DOM2 级事件处理程序</li>
<li>Firefox 不支持 focusin、focusout</li>
<li>blur、focusout 的事件目标是失去焦点的元素；focus、focusin 的事件目标是获得焦点的元素</li></ol></blockquote>
<h3>鼠标与滚轮事件</h3>
<blockquote><ul><li><code>click</code>&nbsp;在用户单击住鼠标按钮或按下回车键时触发。 触发顺序 mousedown mouseup click，如果 mousedown、mouseup 其中之一被取消，就不会触发 click 事件。</li>
<li><code>dblclick</code>&nbsp;触发顺序 mousedown mouseup click mousedown mouseup click dblclick， 如果中间有事件被取消，dblclick 也不会被触发</li>
<li><code>mousedown</code>&nbsp;用户按下了任意鼠标按钮时触发。</li>
<li><code>mouseup</code>&nbsp;用户释放按钮时触发</li>
<li><code>mouseenter</code>&nbsp;在鼠标光标从元素外部首次移动到元素范围之内时触发。不冒泡，而且在光标移动到后代元素上不会触发。DOM2 级事件并没有定义这个事，但 DOM3 级事件将它纳入了规范。IE、Firefox9+和Opera支持这个事件。</li>
<li><code>mouseleave</code>&nbsp;在位于元素上方的鼠标光标移动到元素范围之外时触发。不冒泡，而且在光标移动到后代元素上不会触发。DOM2 级事件并没有定义这个事，但 DOM3 级事件将它纳入了规范。IE、Firefox9+ 和 Opera 支持这个事件。</li>
<li><code>mouseover</code>&nbsp;在鼠标指针位于一个元素外部，然后用户将其首次移入另一个元素边界之内时触发。不能通过键盘触发这个事件。</li>
<li><code>mouseout</code>&nbsp;在鼠标指针位于一个元素上方，然后用户将其移入另一个元素时触发。又移入的另一个元素可能位于前一个元素的外部，也可能是这个元素的子元素。不能通过键盘触发这个事件。</li></ul></blockquote>
<ul><li>用代码说明一下 mouseenter、mouseleave 和 mouseover、mouseout 的区别：</li></ul>
<div>
<pre class="prettyprint linenums"><code>&lt;!DOCTYPE html&gt;<br />
&lt;html lang="zh-cn"&gt;<br />
&lt;head&gt;<br />
    &lt;title&gt;test1&lt;/title&gt;<br />
    &lt;meta charset="utf-8"&gt;<br />
    &lt;link rel="stylesheet" type="text/css" href="test1.css"&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
    &lt;div class="mouseover"&gt;<br />
        &lt;div class="sub-mouseover"&gt;

        &lt;/div&gt;<br />
    &lt;/div&gt;<br />
    &lt;div class="mouseenter"&gt;<br />
        &lt;div class="sub-mouseenter"&gt;

        &lt;/div&gt;<br />
    &lt;/div&gt;<br />
    &lt;script src="test1.js"&gt;&lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>.wrap {<br />
    width: 200px;<br />
    height: 100px;<br />
}

.mouseover {<br />
    background: pink;<br />
}

.mouseenter {<br />
    margin-top: 30px;<br />
    background: gray;<br />
}

.sub-mouseover,<br />
.sub-mouseenter {<br />
    width: 100px;<br />
    height: 50px;<br />
    background: #AE81FF;<br />
}</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>var div1 = document.querySelector(".mouseover"),<br />
    div2 = document.querySelector(".mouseenter");

div1.addEventListener("mouseover", function(){<br />
    console.log("div1 mouseover");<br />
});<br />
div1.addEventListener("mouseout", function(){<br />
    console.log("div1 mouseout");<br />
})

div2.addEventListener("mouseenter", function(){<br />
    console.log("div2 mouseenter");<br />
})<br />
div2.addEventListener("mouseleave", function(){<br />
    console.log("div2 mouseleave");<br />
})</code></pre>
</div>
<ul><li><p>效果图<br /><img referrerpolicy="no-referrer"src="https://luckylzh.github.io/2016/07/30/JavaScript-%E4%BA%8B%E4%BB%B6%E6%80%BB%E7%BB%93/mouseenter.jpg" /></p></li>
<li><p>鼠标由左侧从上到下依次经过所有 div 的情况，输出&nbsp;<code>div1 mouseover</code>&nbsp;<code>div1 mouseout</code>&nbsp;<code>div1 mouseover</code>&nbsp;<code>div1 mouseout</code>&nbsp;<code>div2 mouseenter</code>&nbsp;<code>div2 mouseleave</code></p></li></ul>
<blockquote><ul><li><code>mousemove</code>&nbsp;当鼠标指针在元素内部移动时重复地触发。不能通过键盘触发这个事件。</li>
<li>除了 mouseenter、mousedleave，所有鼠标事件都会冒泡，取消鼠标事件将会影响浏览器的默认行为，也会影响其它事件，因为鼠标事件与其它事件是密不可分的。</li>
<li>关于&nbsp;<code>dblclick</code>&nbsp;IE8 及之前版本中的实现有一个小bug，因此在双击事件中，会跳过第二个mousedown 和click事件，其顺序如下：<code>mousedown</code>&nbsp;<code>mouseup</code>&nbsp;<code>click</code>&nbsp;<code>mouseup</code>&nbsp;<code>dblclick</code>，但还是会触发&nbsp;<code>dblclick</code>&nbsp;事件</li>
<li><strong>客户区坐标位置</strong>：鼠标事件中的&nbsp;<code>event</code>&nbsp;都有&nbsp;<code>clientX</code>&nbsp;<code>clientY</code>&nbsp;属性，表示在视口中客户区的坐标位置，这些值不包括页面滚动的距离，因此这个位置并不表示鼠标在页面上的位置：<br /><img referrerpolicy="no-referrer"src="https://luckylzh.github.io/2016/07/30/JavaScript-%E4%BA%8B%E4%BB%B6%E6%80%BB%E7%BB%93/clientX.jpg" /></li></ul></blockquote>
<blockquote><ul><li><strong>页面坐标位置</strong>：pageX、pageY，这两个属性表示鼠标光标在页面中的位置，在页面没有滚动的情况下，pageX 和 pageY 的值与 clientX、clientY 的值相等。IE8 及更早版本不支持事件对象上的页面坐标，不过使用客户区坐标和滚动信息可以计算出来。这时候需要用到document.body（混杂模式）或document.documentElement（标准模式）中的scrollLeft 和scrollTop 属性。计算过程如下所示：</li></ul></blockquote>
<div>
<pre class="prettyprint linenums"><code>var div = document.getElementById("myDiv");<br />
EventUtil.addHandler(div, "click", function(event){<br />
    event = EventUtil.getEvent(event);<br />
    var pageX = event.pageX,<br />
        pageY = event.pageY;<br />
    if (pageX === undefined){<br />
        pageX = event.clientX + (document.body.scrollLeft ||<br />
            document.documentElement.scrollLeft);<br />
    }<br />
    if (pageY === undefined){<br />
        pageY = event.clientY + (document.body.scrollTop ||<br />
            document.documentElement.scrollTop);<br />
    }<br />
    alert("Page coordinates: " + pageX + "," + pageY);<br />
});</code></pre>
</div>
<blockquote><ul><li><strong>屏幕坐标位置</strong>：screenX、screenY</li>
<li><strong>修改键</strong>&nbsp;用户按住Shift、Ctrl、Alt、Meta（Windows或Cmd，cmd(mac)）时触发鼠标事件，可以在&nbsp;<code>event</code>&nbsp;中获得修改键。</li></ul></blockquote>
<div>
<pre class="prettyprint linenums"><code>var div = document.getElementById("myDiv");<br />
EventUtil.addHandler(div, "click", function(event){<br />
    event = EventUtil.getEvent(event);<br />
    var keys = new Array();<br />
    if (event.shiftKey){<br />
        keys.push("shift");<br />
    }<br />
    if (event.ctrlKey){<br />
        keys.push("ctrl");<br />
    }<br />
    if (event.altKey){<br />
        keys.push("alt");<br />
    }<br />
    if (event.metaKey){<br />
        keys.push("meta");<br />
    }<br />
    alert("Keys: " + keys.join(","));<br />
});</code></pre>
</div>
<blockquote><ul><li>IE9、Firefox、Safari、Chrome 和Opera 都支持这4 个键。IE8 及之前版本不支持metaKey 属性。另外，旧版本的 IE 有自己的一套写法。</li>
<li><strong>相关元素</strong>&nbsp;<code>mouseover</code>&nbsp;<code>mouseout</code>&nbsp;时的 event.relatedTarget，不做详细记录。</li>
<li><strong>鼠标按钮</strong>&nbsp;<code>mousedown</code>&nbsp;<code>mouseup</code>&nbsp;是在按下/释放任意鼠标按钮时触发的，所以通过 event.button： 0(左) 1(中) 2(右) 可以判断按的是哪个键，但是IE8 及更低版本的浏览器不支持，有兼容写法，此处不详细叙述。<code>EventUtil.getButton</code>&nbsp;有详细实现。</li>
<li><strong>mousewheel</strong>&nbsp;<code>event.whellDelta</code>&nbsp;为正数时，向前滚动（回到顶部、页面向下滑动），负数则反过来，这个值是120的倍数，Opera低版本中正负相反，火狐中有自己的一套方法，这里不做详细记录。</li>
<li><strong>触摸设备</strong></li>
<li>不支持dblclick 事件。双击浏览器窗口会放大画面，而且没有办法改变该行为。</li>
<li>轻击可单击元素会触发mousemove 事件。如果此操作会导致内容变化，将不再有其他事件发生；如果屏幕没有因此变化，那么会依次发生mousedown、mouseup 和click 事件。轻击不可单击的元素不会触发任何事件。可单击的元素是指那些单击可产生默认操作的元素（如链接），或者那些已经被指定了onclick 事件处理程序的元素。</li>
<li>mousemove 事件也会触发mouseover 和mouseout 事件。</li>
<li>两个手指放在屏幕上且页面随手指移动而滚动时会触发mousewheel 和scroll 事件。</li>
<li><strong>无障碍性问题</strong></li>
<li>如果需要考虑这个问题，不建议使用&nbsp;<code>click</code>&nbsp;之外的鼠标事件。因为这个不能通过键盘触发，不利于屏幕阅读器访问。此处不详细记录。</li></ul></blockquote>
<h3>键盘与文本事件</h3>
<blockquote><ul><li><code>keydown</code>: 当用户按下键盘上的任意键时触发，而且如果按住不放的话，会重复触发此事件。</li>
<li><code>keypress</code>&nbsp;当用户按下键盘上的字符键时触发，而且如果按住不放的话，会重复触发此事件。按下Esc 键也会触发这个事件。Safari 3.1 之前的版本也会在用户按下非字符键时触发keypress事件。</li>
<li><code>keyup</code>：当用户释放键盘上的键时触发。</li>
<li>触发顺序：<code>keydown</code>、<code>keypress</code>、<code>keyup</code>，<code>keydown</code>、<code>keypress</code>&nbsp;都是在文本框发生变化之前被触发的;&nbsp;<code>keyup</code>&nbsp;事件则是在文本框已经发生变化之后被触发的。</li>
<li>如果用户按下了一个字符键不放，就会重复触发 keydown 和keypress 事件，直到用户松开该键为止。</li>
<li>键盘事件也支持修改键(ctrl等)</li>
<li>keydown、keyup 中的 event 有 keyCode, 与ASCII 码中对应小写字母或数字的编码相同。</li>
<li>keypress 中的 event 有 charCode，这个值是按下的那个键所代表字符的 ASCII 编码，用&nbsp;<code>String.fromCharCode()</code>&nbsp;可以转换成实际的字符</li>
<li>DOM3 级中，有&nbsp;<code>key</code>&nbsp;和&nbsp;<code>char</code>，其中&nbsp;<code>key</code>&nbsp;可以直接得到 "k"、"K"、"Shift" 等，&nbsp;<code>char</code>&nbsp;属性在按下字符键时行为与&nbsp;<code>key</code>&nbsp;相同，在按下非字符键时为&nbsp;<code>null</code>，但是支持还不完整，chrome 总是输出 undefined。</li>
<li><code>keyIdentifier</code>&nbsp;Chrome 已经不推荐使用</li>
<li>表示按下的按键在键盘的位置，比如按下左右侧的shift键，这个值就不同，Chrome 和 Safari 的实现有 bug。</li>
<li><code>textInput</code>: 在文本插入文本框之前会触发textInput 事件。目的是代替keypress，退格键不会触发textInput，但是会触发keypress(只要改变文本)，只有真正可以编辑的区域才会触发textInput,但是keypress获得焦点即可触发。event.data中包含用户的输入，拼音输入法中输入过程的拼音不会触发该事件。</li>
<li>inputMethod 代表用户是怎样输入的，比如通过粘贴的方式，但是支持的浏览器很少。</li></ul></blockquote>
<h3>变动事件</h3>
<p>DOM2 级的变动(mutation)事件能在 DOM 中的某一部分发生变化时给出提示，比如 DOM 节点的插入、移除、特性被修改等等</p>
<h3>HTML5 事件</h3>
<blockquote><ol><li>contextmenu 事件</li></ol></blockquote>
<div>
<pre class="prettyprint linenums"><code>EventUtil.addHandler(window, "load", function(event){<br />
    var div = document.getElementById("myDiv");

    EventUtil.addHandler(div, "contextmenu", function(event){<br />
        event = EventUtil.getEvent(event);<br />
        EventUtil.preventDefault(event);

        var menu = document.getElementById("myMenu");<br />
        menu.style.left = event.clientX + "px";<br />
        menu.style.top = event.clientY + "px";<br />
        menu.style.visibility = "visible";<br />
    });

    EventUtil.addHandler(document, "click", function(event){<br />
        document.getElementById("myMenu").style.visibility = "hidden";<br />
    });<br />
});</code></pre>
</div>
<blockquote><ol><li>beforeunload 事件，用户关闭标签页时提示</li></ol></blockquote>
<div>
<pre class="prettyprint linenums"><code>EventUtil.addHandler(window, "beforeunload", function(event){<br />
        event = EventUtil.getEvent(event);<br />
        var message = "I'm really going to miss you if you go.";<br />
        event.returnValue = message;<br />
        return message;<br />
});</code></pre>
</div>
<blockquote><ol><li>DOMContentLoaded 在形成完整DOM树之后就会触发，不理会图像、JavaScript 文件、CSS 文件或其它资源是否已经下载完毕。其实更应该使用 DOMContentLoaded 而不是 window.onload：</li></ol></blockquote>
<div>
<pre class="prettyprint linenums"><code>EventUtil.addHandler(window, "DOMContentLoaded", function(event){<br />
        alert("Content loaded.");<br />
});<br />
EventUtil.addHandler(window, "load", function(event){<br />
        alert("Window loaded.");<br />
});</code></pre>
</div>
<blockquote><ul><li>IE9+、Firefox、Chrome、Safari 3.1+ 和 Opera9+ 都支持 DOMContentLoaded 事件。</li></ul>
<ol><li>readystatechange 事件，略。</li>
<li>pageshow 和 pagehide 事件，此处要了解 Firefox 和 Opera 有一个特性叫 &ldquo;往返缓存&rdquo;(back-forward cache/bfcache)，用户点击&ldquo;前进&rdquo;、&ldquo;后退&rdquo;按钮时，会将页面缓存在内存。不重新加载，JavaScript的状态会保留。但是无论页面是否来自 bfcache，都会触发 pageshow 事件，pageshow 的事件处理程序的 event 对象中有&nbsp;<code>event.persisted</code>&nbsp;属性，为&nbsp;<code>true</code>&nbsp;代表页面来自bfcache，同样 pagehide 事件触发时，如果页面被保存到 bfcache 中，则该属性为 true。支持pageshow、pagehide 事件的浏览器有 Firefox、Safari5+、Chrome 和 Opera。 IE9 及以前的版本不支持这两个事件。指定了 onunload 事件处理程序的页面会被自动排除在 bfcache 之外。</li>
<li>hashchange 事件。在 window 上触发，event 包含 oldURL、newURL 两个属性。支持该事件的有 IE8+、Firefox3.6+、Safari5+、Chrome 和 Opera10.6+，但oldURL、newURL只有Firefox6+、Chrome和Opera支持。所以最好用 location 来指定当前的 hash：</li></ol></blockquote>
<div>
<pre class="prettyprint linenums"><code>EventUtil.addHandler(window, "hashchange", function(event){<br />
        console.log(location.hash);<br />
})</code></pre>
</div>
<h3>设备事件</h3>
<blockquote><ul><li>orientationchange 事件，屏幕转动。</li></ul></blockquote>
<h3>触摸与手势事件</h3>
<blockquote><ul><li>touchstart: 当手指触摸屏幕时触发；即使已经有一个手指放在了屏幕上也会触发。</li>
<li>touchmove: 当手指在屏幕上滑动时连续地触发。在这个事件发生期间，调用preventDefault() 可以阻止滚动。</li>
<li>touchend：当手指从屏幕上移开时触发。</li>
<li>touchcancel：当系统停止跟踪触摸时触发。关于此事件的确切触发时间，文档中没有明确说明。</li>
<li>event 对象中包含的常见 DOM 属性有：bubbles、cancelable、view、clientX、clientY、screenX、screenY、detail、altKey、shiftKey、ctrlKey 和metaKey。</li>
<li>event 对象中还包含以下用于跟踪触摸的属性：</li></ul>
<ol><li>touches：表示当前跟踪的触摸操作的Touch 对象的数组。</li>
<li>targetTouchs：特定于事件目标的Touch 对象的数组。</li>
<li>changeTouches：表示自上次触摸以来发生了什么改变的Touch 对象的数组。每个Touch 对象包含下列属性:clientX、clientY、pageX、pageY、screenX、screenY、target、identifier(标识触摸的唯一ID)</li></ol></blockquote>
<div>
<pre class="prettyprint linenums"><code>function handleTouchEvent(event) {

    //only for one touch<br />
    if (event.touches.length == 1) {

        var output = document.getElementById("output");<br />
        switch (event.type) {<br />
            case "touchstart":<br />
                output.innerHTML = "Touch started (" + event.touches[0].clientX + "," + event.touches[0].clientY + ")";<br />
                break;<br />
            case "touchend":<br />
                output.innerHTML += "&lt;br&gt;Touch ended (" + event.changedTouches[0].clientX + "," + event.changedTouches[0].clientY + ")";<br />
                break;<br />
            case "touchmove":<br />
                event.preventDefault();  //prevent scrolling<br />
                output.innerHTML += "&lt;br&gt;Touch moved (" + event.changedTouches[0].clientX + "," + event.changedTouches[0].clientY + ")";<br />
                break;<br />
        }<br />
    }<br />
}</code></pre>
</div>
<blockquote><ul><li>一次触摸的事件触发顺序为：touchstart、mouseover、mousemove（一次）、mousedown、mouseup、click、touchend</li>
<li>手势事件：</li></ul>
<ol><li>gesturestart：当一个手指已经按在屏幕上而另一个手指又触摸屏幕时触发。</li>
<li>gesturechange：当触摸屏幕的任何一个手指的位置发生变化时触发。</li>
<li>gestureend：当任何一个手指从屏幕上面移开时触发。</li></ol>
<ul><li>属性有标准的鼠标事件属性，还有两个：rotation(正值表示顺时针)和scale(从1开始)</li></ul></blockquote>
<h2>内存和性能</h2>
<blockquote><ul><li>每个函数都是对象，都会占用内存；内存中的对象越多，性能就越差。</li>
<li>必须事先指定所有事件处理程序而导致的 DOM 访问次数，会延迟整个页面的交互就绪时间。</li></ul></blockquote>
<h3>事件委托</h3>
<div>
<pre class="prettyprint linenums"><code>&lt;body&gt;<br />
    &lt;ul id="myLinks"&gt;<br />
        &lt;li id="goSomewhere"&gt;Go somewhere&lt;/li&gt;<br />
        &lt;li id="doSomething"&gt;Do something&lt;/li&gt;<br />
        &lt;li id="sayHi"&gt;Say hi&lt;/li&gt;<br />
    &lt;/ul&gt;<br />
    &lt;script type="text/javascript"&gt;<br />
    (function(){<br />
        var list = document.getElementById("myLinks");

        EventUtil.addHandler(list, "click", function(event){<br />
            event = EventUtil.getEvent(event);<br />
            var target = EventUtil.getTarget(event);

            switch(target.id){<br />
                case "doSomething":<br />
                    document.title = "I changed the document's title";<br />
                    break;

                case "goSomewhere":<br />
                    location.href = "http://www.wrox.com";<br />
                    break;

                case "sayHi":<br />
                    alert("hi");<br />
                    break;<br />
            }<br />
        });

    })();<br />
    &lt;/script&gt;<br />
&lt;/body&gt;</code></pre>
</div>
<blockquote><ul><li>上面的方法只取得了一个 DOM 元素，只添加了一个事件处理程序，占用的内存更少。</li>
<li>如果将事件委托到 document 中，会更有优势：</li></ul>
<ol><li>document 对象很快就可以访问，而且可以在页面生命周期的任何时点上为它添加事件处理程序（无需等待 DOMContentLoaded 或 load 事件）。</li>
<li>在页面中设置事件处理程序所需的时间少。只添加一个事件处理程序所需的 DOM 引用更少，所花的时间也更少。</li>
<li>整个页面占用的内存空间更少，能够提升整体性能。</li></ol>
<ul><li>最适合采用事件委托技术的事件包块&nbsp;<code>click</code>、<code>mousedown</code>、<code>mouseup</code>、<code>keydown</code>、<code>keyup</code>&nbsp;和&nbsp;<code>keypress</code></li></ul></blockquote>
<h3>移除事件处理程序</h3>
<blockquote><ul><li>如果你知道某个元素即将被移除，那么最好手工移除事件处理程序，因为有的浏览器（尤其是 IE）不会作出恰当地处理，它们很有可能会将对元素和对事件处理程序的引用都保存在内存中。</li>
<li>IE8 及更早的版本在页面被卸载（刷新，切换页面）之前没有清理干净事件处理程序，它们会滞留在内存中，可以通过 onunload 事件处理程序移除所有事件处理程序。</li></ul></blockquote>
<h2>模拟事件</h2>
<blockquote><ul><li>在测试 Web 应用程序，模拟触发事件是一种极其有用的技术。DOM2 级规范为此规定了模拟特定事件的方式，IE9、Opera、Firefox、Chrome 和 Safari 都支持这种方式。IE有它自己模拟事件的方式（IE8 及以下才要用到）</li></ul></blockquote>
<h3>DOM 中的事件模拟</h3>
<blockquote><ul><li>可以在 document 对象上使用 createEvent 方法创建 event 对象。这个方法接收一个参数，即表示要创建的事件类型的字符串。在 DOM2 级中，所有这些字符串都使用英文复数形式，而在 DOM3 级中变成了单数。这个字符串可以是下列几个字符串之一：</li></ul>
<ol><li>UIEvents，DOM3 级中是 UIEvent</li>
<li>MouseEvents: 一般化的鼠标事件，DOM3 级中是 MouseEvent</li>
<li>MutationEvents: 一般化的 DOM 变动事件。 ...</li>
<li>HTMLEvents 一般化的 HTML 事件。没有对应的 DOM3 级事件（HTML 事件被分割到其他类别中）</li></ol></blockquote>
<h4>模拟鼠标事件</h4>
<blockquote><ul><li>createEvent 方法返回的 event 对象中，有 initMouseEvent() 方法，需要传 15 个参数。type(比如"click")，bubbles(Boolean) 是否冒泡，应该设置为 true， cancelable(Boolean) 应该设置为 true，view(几乎总是document.defaultView), detail(通常设置为0), screenX, screenY, clientX, clientY, ctrlKey, altKey, shiftKey, metaKey, button(表示按下了哪个鼠标，默认0), relatedTarget(只有在模拟 mouseover 或 mouseout时使用)</li>
<li>将 event 对象传给 DOM 节点的 dispatchEvent 方法即可触发事件，如下：</li></ul></blockquote>
<div>
<pre class="prettyprint linenums"><code>&lt;body&gt;<br />
    &lt;input type="button" value="Click me" id="myBtn" /&gt;<br />
    &lt;input type="button" value="Send click to the other button" id="myBtn2" /&gt;<br />
    &lt;p&gt;This example works in DOM-compliant browsers (not IE).&lt;/p&gt;<br />
    &lt;script type="text/javascript"&gt;

    (function(){<br />
        var btn = document.getElementById("myBtn");<br />
        var btn2 = document.getElementById("myBtn2");

        EventUtil.addHandler(btn, "click", function(event){<br />
            alert("Clicked!");<br />
            alert(event.screenX);   //100<br />
        });

        EventUtil.addHandler(btn2, "click", function(event){<br />
            //create event object<br />
            var event = document.createEvent("MouseEvents");

            //initialize the event object<br />
            event.initMouseEvent("click", true, true, document.defaultView, 0, 100, 0, 0, 0, false,<br />
                                 false, false, false, 0, btn2);

            //fire the event<br />
            btn.dispatchEvent(event);

        });

    })();<br />
    &lt;/script&gt;<br />
&lt;/body&gt;</code></pre>
</div>
<h4>模拟键盘事件</h4>
<blockquote><ul><li>"DOM2 级事件"的草案中本来包含了键盘事件，但在定稿前又被删除了；Firefox 根据其草案实现了键盘事件。但跟 "DOM3 级事件"中的键盘事件有很大区别。</li>
<li>DOM3 级规定，调用&nbsp;<code>createEvent()</code>&nbsp;并传入 "KeyboardEvent" ，返回键盘事件，有&nbsp;<code>initKeyEvent()</code>&nbsp;方法。这个方法接收一下参数</li>
<li>type, bubbles, cancelable, view, key(按下的键的键码), location(按下了哪里的键，0：主键盘，1：左，2：右，3：数字键盘，4：虚拟键盘，5：手柄), modifiers: 空格分隔的修改键列表，如 "Shift", repeat(在一行中按了这个键多少次)<br />DOM3 级不提倡&nbsp;<code>keypress</code>&nbsp;事件， 因此只能模拟&nbsp;<code>keydown</code>&nbsp;<code>keyup</code></li></ul></blockquote>
<h3>IE 中的事件模拟</h3>
<p>第一步：document.createEventObject()<br />第二步: 通过赋值的方式初始化事件对象，就是&nbsp;<code>event.screenX = 0</code>&nbsp;这些<br />第三步：btn.fireEvent("onclick", event);</p>
<h3>关于标准</h3>
<ul><ul><li><p>由于标准在变，现在 DOM3 级事件已经不推荐使用&nbsp;<code>document.createEvent</code>&nbsp;的方式，也不推荐通过 event 对象&nbsp;<code>initKeyEvent</code>或者&nbsp;<code>initKeybordEvent</code>，书中的跨浏览器代码在狐火中报错了，因为火狐开始支持 DOM3 级事件，标准又在变，现在 DOM3 级标准推荐通过构造函数的方式初始化模拟事件，但这也还是草案。</p></li>
<li>关于跨浏览器模拟事件，粗略了解一下 jQuery 的做法，使用了很多 hack，让本来不冒泡的 focus、blur 可以做事件委托，里面的内容还是很多，得另外总结一下。</li>
<li><p>期待标准被普及的一天：</p></li></ul></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o1zzlq.html">OA项目&mdash;&mdash;总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pm41d9.html">分配问题与Hungarian算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlwgw68.html">Java面向对象思想解决猜拳问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnrde29.html">Javascript 笔记与总结（2-17）事件委托</a>
		</li>
						<li><a href="https://www.batexi.com/a/m966g2n9.html">强调语气&amp;lt&semi;strong&amp;gt&semi;和&amp;lt&semi;em&amp;gt&semi;标签&comma;文字设置单独样式&amp;lt&semi;span&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x32jw9.html">Demo学习： FileUpload</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzjy208.html">在Windows上使用CodeLite&plus;MinGW&plus;Clang进行开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwg7e9.html">SUM游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpz6z69.html">ROS&lowbar;Kinetic&lowbar;27 在ROS中使用Cartographer进行SLAM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg2lyr8.html">UEditor单图上传跨域问题解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y056r8.html">读取控制器PHP代码文件，并分析数据存到数据库，再重新读出生成PHP文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj06ej9.html">pip更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwxz778.html">day31 网络编程，多进程多线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkm7n9.html">viewDidLoad&comma; viewWillDisappear&comma; viewWillAppear等区别及各自的加载顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53l4mq.html">本体【Ontology】综述</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy7jm39.html">ajax传输中文参数乱码，本地使用tomcat不乱码，liunx&plus;weblogic乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlkz6r9.html">【第九课】MriaDB密码重置和慢查询日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emz0ye9.html">【MongoDB】NoSQL Manager for MongoDB 教程（进阶篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pxdp3q.html">Android 新浪博客分享问题总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1yzke9.html">git配置用户名邮箱</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495ezdm9.html">【C&num;】 目前的技能点</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8egrek9.html">android及IOS的测试中容易疏漏或者测漏的点&mdash;&mdash;持续更新</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy70vxq.html">安卓手机开机开启指定Activity</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8egrje9.html">树莓派&lpar;raspberry pi&rpar;学习4&colon; 更改键盘布局（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4o6zj8.html">基于Java的WebSocket推送【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlrxp0q.html">PHP各种缓存</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnxkjj9.html">Log4j基本用法----日志级别</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q75vzj9.html">链接，光标，DHTML，缩放</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r2lnrq.html">redhat 5 中文乱码及中文输入法解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r2l4rq.html">Spring JDBC 访问MSSQL</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
